## ipxe 1.0.0+git-20161027.b991c67+really20150424.a25a16d

=== debian/changelog ===
ipxe (1.0.0+git-20161027.b991c67+really20150424.a25a16d-1ubuntu2) artful; urgency=medium

  * debian/patches/handle-dhcp-nack.patch: Handle DHCP NAK and send a
    re-discover. (LP: #1707999)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 12 Oct 2017 16:25:52 -0400

ipxe (1.0.0+git-20161027.b991c67+really20150424.a25a16d-1ubuntu1) artful; urgency=medium

  * Revert to the former git snapshot 20150424.a25a16d to fix changed
    rom sizes that break cross release migrations (LP: #1713490).
    This makes it effectively identical to 1.0.0+git-20150424.a25a16d-1ubuntu2
    in regard to the upstream source, but keeps the changes to debian/*.
    On next merge we need to either ensure that rom sizes don't change, or
    that we can encapsulate that in qemu so that on forward migration it is
    taken care off.
    - This brings back debian/patches/0002-Don-t-use-libiberty.patch as needed
      on the older source.
    - Adapt d/p/0001-rom-change-banner-timeout.diff.patch to former state to
      match old source.
    - drop d/p/util-elf2efi-GNU_SOURCE.patch as it was not needed on old
      source
  * Fix FTBFS with newer perl versions (were dropped due to the revert above
    but is needed to build in artful)
    - d/p/0006-build-Fix-.ids.o-creation-for-drivers-not-in-the-all.patch
    - d/p/0007-build-Remove-nested-my-declaration.patch
  * d/util/check-rom-sizes, d/rules: check sizes of generated roms to avoid
    accidentially breaking KVM live migration on updates/fixes.

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 29 Aug 2017 10:37:57 +0200

ipxe (1.0.0+git-20161027.b991c67-1ubuntu1) artful; urgency=medium

  * Merge from Debian stable. Remaining changes:
    - d/p/enable-https.patch: Enable HTTPS support.
    - Split grub integration from ipxe->grub-ipxe.
      - d/control: add package and adapt dependencies
      - d/[grub-]ipxe.install: move some files to grub-ipxe
      - rename d/ipxe.post* to d/grub-ipxe-post*
    - Install ne.rom as pxe-ne2k_isa.rom
      - d/ipxe-qemu.install: Install ne.rom as pxe-ne2k_isa.rom.
      - d/ipxe-qemu.links: compat link for ne.rom
    - d/ipxe-qemu.links: Add compat links from /usr/share/qemu
      to /usr/lib/ipxe/qemu.
    - d/p/0004-fix_no-pie_option.patch: correct -no-pie option
      to build without pie

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 17 Aug 2017 08:40:41 +0200

ipxe (1.0.0+git-20150424.a25a16d-1ubuntu2) yakkety; urgency=medium

  * debian/patches/0004-fix_no-pie_option.patch: correct -no-pie
    option to build without pie

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 28 Apr 2016 23:55:40 -0700

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Bastian Blank <waldi@debian.org>
Build-Depends:
 debhelper (>> 10), dh-exec,
 xorriso, isolinux, syslinux-common, syslinux-utils, dosfstools, mtools,
 binutils-dev, liblzma-dev, zlib1g-dev,
Standards-Version: 3.9.6
Homepage: http://ipxe.org/
#Vcs-Git: git://git.debian.org/collab-maint/ipxe.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/ipxe.git;a=summary

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ipxe-qemu, grub-ipxe, ${misc:Depends}
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards in
 as boot ROMs.

Package: grub-ipxe
Architecture: all
Suggests: grub-pc (>= 1.96)
Depends: ${misc:Depends}
Description: Network booting from GRUB using iPXE
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package adds a menu entry to grub2 for network booting using iPXE.

## ipxe 1.0.0+git-20180124.fbe8c52d

=== debian/changelog ===
ipxe (1.0.0+git-20180124.fbe8c52d-0ubuntu4) cosmic; urgency=medium

  * Build ROMs for QEMU with CONFIG=qemu (LP: #1789319)

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 10 Sep 2018 14:56:17 +0200

ipxe (1.0.0+git-20180124.fbe8c52d-0ubuntu3) cosmic; urgency=medium

  * debian/patches/fix-elf2efi-plt-relocation.diff: Cherry-pick fix from
    ipxe devel mailing list to handle R_X86_64_PLT32 relocations.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 10 Sep 2018 14:27:35 +0200

ipxe (1.0.0+git-20180124.fbe8c52d-0ubuntu2) bionic; urgency=medium

  * debian/copyright: update copyright information to satisfy lintian
    dep5 checks (LP: #1747071)
  * d/p/enable-https.patch: adding proper dep3 header

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 05 Feb 2018 15:09:28 +0100

ipxe (1.0.0+git-20180124.fbe8c52d-0ubuntu1) bionic; urgency=medium

  * Merge new upstream release 20180124.fbe8c52d with last "new"
    Ubuntu packaging 1.0.0+git-20161027.b991c67-1ubuntu1 and the
    fixes since 1.0.0+git-20161027.b991c67+really20150424.a25a16d-1ubuntu1
    Remaining Changes:
    - d/p/enable-https.patch: Enable HTTPS support.
    - Split grub integration from ipxe->grub-ipxe.
      - d/control: add package and adapt dependencies
      - d/[grub-]ipxe.install: move some files to grub-ipxe
      - rename d/ipxe.post* to d/grub-ipxe-post*
    - Install ne.rom as pxe-ne2k_isa.rom
      - d/ipxe-qemu.install: Install ne.rom as pxe-ne2k_isa.rom.
      - d/ipxe-qemu.links: compat link for ne.rom
    - d/ipxe-qemu.links: Add compat links from /usr/share/qemu
      to /usr/lib/ipxe/qemu.
    - d/util/check-rom-sizes, d/rules: check sizes of generated roms to avoid
      accidentially breaking KVM live migration on updates/fixes.
    - debian/patches/handle-dhcp-nack.patch: Handle DHCP NAK and send a
      re-discover. (LP 1707999)
  * Dropped changes (upstream):
    - d/p/0004-fix_no-pie_option.patch: correct -no-pie option
      to build without pie
  * Added Changes:
    - updated debian/patches/util-elf2efi-GNU_SOURCE.patch to match latest
      upstream.
    - add new rom for vmxnet3 (LP: #1737211)
      - d/ipxe-qemu.install: install new rom
      - d/util/check-rom-sizes: check new rom as well
    - handling of efi rom size changes (LP: #1713490)
      - d/util/check-rom-sizes: bump efi rom sizes
      - d/control: break older qemu versions to ensure the new sized roms
        are only associated with new qemu versions.
    - d/util/check-rom-sizes: update description

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 24 Jan 2018 15:00:36 +0100

## ipxe 1.0.0+git-20190109.133f4c4

=== debian/changelog ===
ipxe (1.0.0+git-20190109.133f4c4-0ubuntu3) focal; urgency=medium

  [Alkis Georgopoulos]
  * d/tree/ipxe/etc/grub.d/20_ipxe: Make grub-ipxe work under UEFI
    (LP: #1811496)
    - Use ipxe.efi under UEFI
    - Save default entry when iPXE is selected
  [Sharon Dagan]
  - d/tree/ipxe/etc/grub.d/20_ipxe: Identify ipxe grub menu entry in
    an easier way (LP: #1858374)

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Mon, 06 Jan 2020 18:59:25 +0000

ipxe (1.0.0+git-20190109.133f4c4-0ubuntu2) disco; urgency=medium

  * Add e1000e firmware for qemu. (closes: #884240)
    - d/ipxe-qemu.install: install new rom
    - d/util/check-rom-sizes: check new rom

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 19 Feb 2019 17:17:04 +0100

ipxe (1.0.0+git-20190109.133f4c4-0ubuntu1) disco; urgency=medium

  * Merge new upstream release 1.0.0+git-20190109.133f4c4
    Remaining Changes:
    - d/p/enable-https.patch: Enable HTTPS support.
    - Split grub integration from ipxe->grub-ipxe.
      - d/control: add package and adapt dependencies
      - d/[grub-]ipxe.install: move some files to grub-ipxe
      - rename d/ipxe.post* to d/grub-ipxe-post*
    - Install ne.rom as pxe-ne2k_isa.rom
      - d/ipxe-qemu.install: Install ne.rom as pxe-ne2k_isa.rom.
      - d/ipxe-qemu.links: compat link for ne.rom
    - d/ipxe-qemu.links: Add compat links from /usr/share/qemu
      to /usr/lib/ipxe/qemu.
    - d/util/check-rom-sizes, d/rules: check sizes of generated roms to avoid
      accidentially breaking KVM live migration on updates/fixes.
    - handling of efi rom size changes in Bionic (LP 1713490)
      - d/util/check-rom-sizes: bump efi rom sizes
      - d/control: break older qemu versions to ensure the new sized roms
        are only associated with new qemu versions.
    - debian/patches/handle-dhcp-nack.patch: Handle DHCP NAK and send a
      re-discover. (LP 1707999)
    - updated debian/patches/util-elf2efi-GNU_SOURCE.patch to match latest
      upstream.
    - add new rom for vmxnet3 (LP 1737211)
      - d/ipxe-qemu.install: install new rom
        are only associated with new qemu versions.
    - Build ROMs for QEMU with CONFIG=qemu (LP: 1789319)
    - d/p/0005-strip-802.1Q-VLAN-0-priority-tags.patch: Strip 802.1Q VLAN 0
      priority tags; Fixes PXE when VLAN tag is 0. (LP: 1805920)
    - debian/copyright: update copyright information to satisfy lintian
      dep5 checks (LP: 1747071)
  * Dropped changes (upstream):
    - debian/patches/fix-elf2efi-plt-relocation.diff: Cherry-pick fix from
      ipxe devel mailing list to handle R_X86_64_PLT32 relocations.

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 09 Jan 2019 11:09:29 +0100

ipxe (1.0.0+git-20180124.fbe8c52d-0ubuntu5) disco; urgency=medium

  * d/p/0005-strip-802.1Q-VLAN-0-priority-tags.patch: Strip 802.1Q VLAN 0
    priority tags; Fixes PXE when VLAN tag is 0. (LP: #1805920)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 10 Dec 2018 16:26:42 -0500

=== debian/control ===
--- 
+++ 
@@ -32,6 +32,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Breaks: qemu-system-x86 (<< 1:2.11+dfsg-1ubuntu1~)
 Description: PXE boot firmware - ROM images for qemu
  iPXE is network boot firmware.  It supports a variety of network cards,
  including some wireless cards, and variety of network protocols (traditional

## ipxe 1.0.0+git-20190125.36a4c85

=== debian/changelog ===
ipxe (1.0.0+git-20190125.36a4c85-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply upstream patch to fix FTBFS with gcc 10. (Closes: #966942)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 07 Feb 2021 17:25:50 +0000

ipxe (1.0.0+git-20190125.36a4c85-5) unstable; urgency=medium

  * Cleanup src/bin correctly. (closes: #952275)

 -- Bastian Blank <waldi@debian.org>  Tue, 25 Feb 2020 21:44:34 +0100

ipxe (1.0.0+git-20190125.36a4c85-4) unstable; urgency=medium

  * Use new source format instead of own rules.
  * Use debhelper 12.
  * Move ipxe.efi into /boot. (closes: #947267)

 -- Bastian Blank <waldi@debian.org>  Thu, 02 Jan 2020 21:36:39 +0100

ipxe (1.0.0+git-20190125.36a4c85-3) unstable; urgency=medium

  * Combine legacy and EFI rom again. (closes: #947024)

 -- Bastian Blank <waldi@debian.org>  Thu, 19 Dec 2019 19:32:59 +0100

ipxe (1.0.0+git-20190125.36a4c85-2) unstable; urgency=medium

  * Add Vcs information.
  * Include snponly.efi. (closes: #944321)

 -- Bastian Blank <waldi@debian.org>  Sat, 14 Dec 2019 21:43:28 +0100

ipxe (1.0.0+git-20190125.36a4c85-1) unstable; urgency=medium

  * New snapshot. (closes: #832765, #906365)
  * Add e1000e and vmxnet3 firmware for qemu. (closes: #884240, #868124)

 -- Bastian Blank <waldi@debian.org>  Sat, 09 Feb 2019 17:41:37 +0100

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Bastian Blank <waldi@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dpkg-source-gitarchive,
 dh-exec,
 xorriso, isolinux, syslinux-common, syslinux-utils, dosfstools, mtools,
 binutils-dev, liblzma-dev, zlib1g-dev,
Standards-Version: 3.9.6
Homepage: http://ipxe.org/
Vcs-Git: https://salsa.debian.org/waldi/ipxe.git
Vcs-Browser: https://salsa.debian.org/waldi/ipxe

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards in
 as boot ROMs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export ISOLINUX_BIN=/usr/lib/syslinux/

VERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')

%:
	+dh $@

override_dh_auto_configure:
	cp debian/config/* src/config/local

src/bin-i386-pcbios/% src/bin-x86_64-efi/%:
	dh_auto_build --sourcedirectory=src -- V=1 NO_WERROR=1 VERSION="$(VERSION)" $(subst src/,,$@)

src/bin-combined/%.efirom: src/bin-i386-pcbios/%.rom src/bin-x86_64-efi/%.efirom
	@[ -d $(dir $@) ] || mkdir $(dir $@)
	src/util/catrom.pl $^ > $@

src/bin-combined/%.iso: src/bin-i386-pcbios/%.lkrn src/bin-x86_64-efi/%.efi
	@[ -d $(dir $@) ] || mkdir $(dir $@)
	debian/util/geniso $@ $^

override_dh_auto_build: $(shell grep -hoE 'src/bin(-[^/]*)?/\S+' debian/*.install)

override_dh_auto_clean:
	$(MAKE) -C src veryclean
	rm -fr src/bin*
	rm -f src/config/local/*

.NOTPARALLEL:
.SECONDARY:

## ipxe 1.0.0+git-20231218.f22879c

=== debian/changelog ===
ipxe (1.0.0+git-20231218.f22879c-6) unstable; urgency=medium

  * rsync upstream from https://github.com/ipxe/ipxe
  * Modify version number acquisition method

 -- bluesky <chenchongbiao@deepin.org>  Mon, 18 Dec 2023 17:03:23 +0800

## ipxe 1.21.1%2Bgit

=== src/arch/x86/Makefile ===
# Assembler section type character
#
ASM_TCHAR	:= @
ASM_TCHAR_OPS	:= @

# Include x86-specific headers
#
INCDIRS		:= arch/$(ARCH)/include arch/x86/include $(INCDIRS)

# x86-specific directories containing source files
#
SRCDIRS		+= arch/x86/core
SRCDIRS		+= arch/x86/image
SRCDIRS		+= arch/x86/interface/pcbios
SRCDIRS		+= arch/x86/interface/pxe
SRCDIRS		+= arch/x86/interface/efi
SRCDIRS		+= arch/x86/interface/vmware
SRCDIRS		+= arch/x86/interface/syslinux
SRCDIRS		+= arch/x86/prefix
SRCDIRS		+= arch/x86/hci/commands
SRCDIRS		+= arch/x86/drivers/xen
SRCDIRS		+= arch/x86/drivers/hyperv
SRCDIRS		+= arch/x86/transitions

# disable valgrind
CFLAGS		+= -DNVALGRIND

# Define version string for lkrnprefix.S
#
CFLAGS_lkrnprefix	+= -DVERSION="\"$(VERSION)\""

# Include Hyper-V driver in the all-drivers build
#
DRIVERS_hyperv += hyperv

## ipxe 1.21.1%2bgit

=== src/arch/i386/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN32)

# Force i386-only instructions
#
CFLAGS		+= -march=i386

# Code size reduction.
#
CFLAGS		+= -fomit-frame-pointer

# Code size reduction.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -fstrength-reduce
endif

# Code size reduction.  gcc3 needs a different syntax to gcc2 if you
# want to avoid spurious warnings.
#
ifeq ($(CCTYPE),gcc)
GCC_VERSION	:= $(subst ., ,$(shell $(CC) -dumpversion))
GCC_MAJOR	:= $(firstword $(GCC_VERSION))
ifeq ($(GCC_MAJOR),2)
CFLAGS		+= -malign-jumps=1 -malign-loops=1 -malign-functions=1
else
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1
endif # gcc2
endif # gcc

# Code size reduction.  This is almost always a win.  The kernel uses
# it, too.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mpreferred-stack-boundary=2
endif

# Code size reduction.  Use regparm for all functions - C functions
# called from assembly (or vice versa) need __asmcall now
#
CFLAGS		+= -mregparm=3

# Code size reduction.  Use -mrtd (same __asmcall requirements as above)
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mrtd
endif

# Code size reduction.  This is the logical complement to -mregparm=3.
# It doesn't currently buy us anything, but if anything ever tries to
# return small structures, let's be prepared
#
CFLAGS		+= -freg-struct-return

# Force 32-bit code even on an x86-64 machine
#
CFLAGS		+= -m32
ASFLAGS		+= --32
ifeq ($(HOST_OS),FreeBSD)
LDFLAGS		+= -m elf_i386_fbsd
else ifeq ($(HOST_OS),OpenBSD)
LDFLAGS		+= -m elf_i386_obsd
else
LDFLAGS		+= -m elf_i386
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# We need to undefine the default macro "i386" when compiling .S
# files, otherwise ".arch i386" translates to ".arch 1"...
#
CFLAGS			+= -Ui386

# i386-specific directories containing source files
#
SRCDIRS		+= arch/i386/core
SRCDIRS		+= arch/i386/tests

# Include common x86 Makefile
#
MAKEDEPS	+= arch/x86/Makefile
include arch/x86/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/i386/Makefile.$(PLATFORM)
include arch/i386/Makefile.$(PLATFORM)

## ipxe 1.21.1+git

=== src/Makefile ===
###############################################################################
#
# Initialise various variables
#

CLEANUP		:=
CFLAGS		:=
ASFLAGS		:=
LDFLAGS		:=
HOST_CFLAGS	:=
MAKEDEPS	:= Makefile
CROSS_COMPILE	?= $(CROSS)
SYMBOL_PREFIX	:=

###############################################################################
#
# Locations of tools
#
HOST_CC		:= gcc
RM		:= rm -f
TOUCH		:= touch
MKDIR		:= mkdir
CP		:= cp
ECHO		:= echo
PRINTF		:= printf
PERL		:= perl
PYTHON		:= python
TRUE		:= true
TRUNCATE	:= truncate
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
SIZE		= $(CROSS_COMPILE)size
AR		= $(CROSS_COMPILE)ar
RANLIB		= $(CROSS_COMPILE)ranlib
OBJCOPY		= $(CROSS_COMPILE)objcopy
NM		= $(CROSS_COMPILE)nm
OBJDUMP		= $(CROSS_COMPILE)objdump
OPENSSL		:= openssl
CSPLIT		:= csplit
PARSEROM	:= ./util/parserom.pl
FIXROM		:= ./util/fixrom.pl
SYMCHECK	:= ./util/symcheck.pl
SORTOBJDUMP	:= ./util/sortobjdump.pl
PADIMG		:= ./util/padimg.pl
LICENCE		:= ./util/licence.pl
NRV2B		:= ./util/nrv2b
ZBIN32		:= ./util/zbin32
ZBIN64		:= ./util/zbin64
ELF2EFI32	:= ./util/elf2efi32
ELF2EFI64	:= ./util/elf2efi64
EFIROM		:= ./util/efirom
EFIFATBIN	:= ./util/efifatbin
EINFO		:= ./util/einfo
GENKEYMAP	:= ./util/genkeymap.py
DOXYGEN		:= doxygen
LCAB		:= lcab
QEMUIMG		:= qemu-img

###############################################################################
#
# SRCDIRS lists all directories containing source files.
#
SRCDIRS		:=
SRCDIRS		+= libgcc
SRCDIRS		+= core
SRCDIRS		+= net net/tcp net/udp net/infiniband
SRCDIRS		+= image
SRCDIRS		+= drivers/bus
SRCDIRS		+= drivers/net
SRCDIRS		+= drivers/net/e1000
SRCDIRS		+= drivers/net/e1000e
SRCDIRS		+= drivers/net/igb
SRCDIRS		+= drivers/net/igbvf
SRCDIRS		+= drivers/net/phantom
SRCDIRS		+= drivers/net/vxge
SRCDIRS		+= drivers/net/efi
SRCDIRS		+= drivers/net/tg3
SRCDIRS		+= drivers/net/bnxt
SRCDIRS		+= drivers/net/sfc
SRCDIRS		+= drivers/net/marvell
SRCDIRS		+= drivers/block
SRCDIRS		+= drivers/nvs
SRCDIRS		+= drivers/bitbash
SRCDIRS		+= drivers/gpio
SRCDIRS		+= drivers/infiniband
SRCDIRS		+= drivers/infiniband/mlx_utils_flexboot/src
SRCDIRS		+= drivers/infiniband/mlx_utils/src/public
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_reg_access
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_nvconfig
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_vmac
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_blink_leds
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_link_speed
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_mtu
SRCDIRS		+= drivers/infiniband/mlx_nodnic/src
SRCDIRS		+= drivers/usb
SRCDIRS		+= drivers/uart
SRCDIRS		+= interface/pxe interface/efi interface/smbios
SRCDIRS		+= interface/bofm
SRCDIRS		+= interface/xen
SRCDIRS		+= interface/hyperv
SRCDIRS		+= tests
SRCDIRS		+= crypto crypto/mishmash
SRCDIRS		+= hci hci/commands hci/tui
SRCDIRS		+= hci/mucurses hci/mucurses/widgets
SRCDIRS		+= hci/keymap
SRCDIRS		+= usr
SRCDIRS		+= config

# These directories contain code that is not eligible for UEFI Secure
# Boot signing.
#
SRCDIRS_INSEC	+= net/oncrpc
SRCDIRS_INSEC	+= net/80211
SRCDIRS_INSEC	+= drivers/net/rtl818x
SRCDIRS_INSEC	+= drivers/net/ath
SRCDIRS_INSEC	+= drivers/net/ath/ath5k
SRCDIRS_INSEC	+= drivers/net/ath/ath9k

# NON_AUTO_SRCS lists files that are excluded from the normal
# automatic build system.
#
NON_AUTO_SRCS	:=
NON_AUTO_SRCS	+= core/version.c
NON_AUTO_SRCS	+= drivers/net/prism2.c

# INCDIRS lists the include path
#
INCDIRS		:=
INCDIRS		+= include .

###############################################################################
#
# Default build target: build the most common targets and print out a
# helpfully suggestive message
#
ALL		:= bin/blib.a bin/ipxe.dsk bin/ipxe.lkrn bin/ipxe.iso \
		   bin/ipxe.usb bin/ipxe.pxe bin/undionly.kpxe bin/rtl8139.rom \
		   bin/8086100e.mrom bin/80861209.rom bin/10500940.rom \
		   bin/10222000.rom bin/10ec8139.rom bin/1af41000.rom \
		   bin/8086100f.mrom bin/808610d3.mrom bin/15ad07b0.rom

all : $(ALL)
	@$(ECHO) '==========================================================='
	@$(ECHO)
	@$(ECHO) 'To create a bootable floppy, type'
	@$(ECHO) '    cat bin/ipxe.dsk > /dev/fd0'
	@$(ECHO) 'where /dev/fd0 is your floppy drive.  This will erase any'
	@$(ECHO) 'data already on the disk.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable USB key, type'
	@$(ECHO) '    cat bin/ipxe.usb > /dev/sdX'
	@$(ECHO) 'where /dev/sdX is your USB key, and is *not* a real hard'
	@$(ECHO) 'disk on your system.  This will erase any data already on'
	@$(ECHO) 'the USB key.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable CD-ROM, burn the ISO image '
	@$(ECHO) 'bin/ipxe.iso to a blank CD-ROM.'
	@$(ECHO)
	@$(ECHO) 'These images contain drivers for all supported cards.  You'
	@$(ECHO) 'can build more customised images, and ROM images, using'
	@$(ECHO) '    make bin/<rom-name>.<output-format>'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Comprehensive build target: build a selection of cross-platform
# targets to expose potential build errors that show up only on
# certain platforms
#
everything :
	$(Q)$(MAKE) --no-print-directory $(ALL) \
		bin/3c509.rom bin/intel.rom bin/intel.mrom \
		bin-x86_64-pcbios/8086100e.mrom bin-x86_64-pcbios/intel.rom \
		bin-x86_64-pcbios/ipxe.usb bin-x86_64-pcbios/ipxe.pxe \
		bin-x86_64-pcbios/undionly.kpxe \
		bin-i386-efi/ipxe.efi bin-i386-efi/ipxe.efidrv \
		bin-i386-efi/ipxe.efirom \
		bin-x86_64-efi/ipxe.efi bin-x86_64-efi/ipxe.efidrv \
		bin-x86_64-efi/ipxe.efirom \
		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux \
		bin-i386-linux/tests.linux bin-x86_64-linux/tests.linux

###############################################################################
#
# VMware build target: all ROMs used with VMware
#
vmware : bin/8086100f.mrom bin/808610d3.mrom bin/10222000.rom bin/15ad07b0.rom
	@$(ECHO) '==========================================================='
	@$(ECHO) 
	@$(ECHO) 'Available ROMs:'
	@$(ECHO) '    bin/8086100f.mrom -- intel/e1000'
	@$(ECHO) '    bin/808610d3.mrom -- intel/e1000e'
	@$(ECHO) '    bin/10222000.rom  -- vlance/pcnet32'
	@$(ECHO) '    bin/15ad07b0.rom  -- vmxnet3'
	@$(ECHO) 
	@$(ECHO) 'For more information, see https://ipxe.org/howto/vmware'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Build targets that do nothing but might be tried by users
#
configure :
	@$(ECHO) "No configuration needed."

install :
	@$(ECHO) "No installation required."

###############################################################################
#
# Version number calculations
#
ifneq ($(wildcard ../.git),)
VERSIONS := $(shell git describe --tags --always --long --abbrev=1 --match "v*")
VERSION_TUPLE	:= $(subst ., ,$(subst -, ,$(patsubst v%,%,$(VERSIONS))))
VERSION_MAJOR	:= $(word 1,$(VERSION_TUPLE))
VERSION_MINOR	:= $(word 2,$(VERSION_TUPLE))
VERSION_PATCH	:= $(word 3,$(VERSION_TUPLE))
ifeq ($(word 4,$(VERSION_TUPLE)),0)
EXTRAVERSION	:=
else
EXTRAVERSION	:= +
endif
GITVERSION	= $(word 5,$(VERSION_TUPLE))
else
VERSION_MAJOR	= 1
VERSION_MINOR	= 0
VERSION_PATCH	= 0
EXTRAVERSION	= +
endif
MM_VERSION	= $(VERSION_MAJOR).$(VERSION_MINOR)
VERSION		= $(MM_VERSION).$(VERSION_PATCH)$(EXTRAVERSION)
ifneq ($(GITVERSION),)
VERSION		+= ($(GITVERSION))
endif
version :
	@$(ECHO) "$(VERSION)"

###############################################################################
#
# Predefined build shortcuts (for e.g. bin/ipxe.iso)

# All drivers (excluding USB)
#
DRIVERS_ipxe	= $(DRIVERS_net) $(DRIVERS_infiniband) \
		  $(DRIVERS_xen) $(DRIVERS_hyperv)

# Raspberry Pi
#
DRIVERS_rpi	= smsc95xx lan78xx

###############################################################################
#
# Drag in the bulk of the build system
#

MAKEDEPS	+= Makefile.housekeeping
include Makefile.housekeeping

=== src/arch/arm/Makefile ===
# Assembler section type character
#
ASM_TCHAR	:= %
ASM_TCHAR_OPS	:= %%

# Include ARM-specific headers
#
INCDIRS		:= arch/$(ARCH)/include arch/arm/include $(INCDIRS)

# ARM-specific directories containing source files
#
SRCDIRS		+= arch/arm/core
SRCDIRS		+= arch/arm/interface/efi

=== src/arch/arm32/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN32)

# ARM32-specific directories containing source files
#
SRCDIRS		+= arch/arm32/core
SRCDIRS		+= arch/arm32/libgcc

# ARM32-specific flags
#
CFLAGS		+= -mthumb -mcpu=cortex-a15 -mabi=aapcs
CFLAGS		+= -mword-relocations
ASFLAGS		+= -mthumb -mcpu=cortex-a15

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# EFI requires that enums are always 32 bits, and nothing else
# currently cares
#
CFLAGS		+= -fno-short-enums

# Include common ARM Makefile
MAKEDEPS	+= arch/arm/Makefile
include arch/arm/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/arm32/Makefile.$(PLATFORM)
include arch/arm32/Makefile.$(PLATFORM)

=== src/arch/arm64/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN64)

# ARM64-specific directories containing source files
#
SRCDIRS		+= arch/arm64/core

# ARM64-specific flags
#
CFLAGS		+= -mlittle-endian -mcmodel=small
CFLAGS		+= -fomit-frame-pointer
ASFLAGS		+= -mabi=lp64 -EL

# We want to specify the LP64 model.  There is an explicit -mabi=lp64
# on GCC 4.9 and later, and no guarantee as to which is the default
# model.  In earlier versions of GCC, there is no -mabi option and the
# default appears to be LP64 anyway.
#
ifeq ($(CCTYPE),gcc)
LP64_TEST = $(CC) -mabi=lp64 -x c -c /dev/null -o /dev/null >/dev/null 2>&1
LP64_FLAGS := $(shell $(LP64_TEST) && $(ECHO) '-mabi=lp64')
WORKAROUND_CFLAGS += $(LP64_FLAGS)
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# Include common ARM Makefile
MAKEDEPS	+= arch/arm/Makefile
include arch/arm/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/arm64/Makefile.$(PLATFORM)
include arch/arm64/Makefile.$(PLATFORM)

=== src/arch/loong64/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN64)

# Assembler section type character
#
ASM_TCHAR	:= @
ASM_TCHAR_OPS	:= @

# LoongArch64-specific flags
#
CFLAGS		+= -fstrength-reduce -fomit-frame-pointer
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1

# Check if -mno-explicit-relocs is valid
ifeq ($(CCTYPE),gcc)
MNER_TEST = $(CC) -mno-explicit-relocs -x c -c /dev/null -o /dev/null >/dev/null 2>&1
MNER_FLAGS := $(shell $(MNER_TEST) && $(ECHO) '-mno-explicit-relocs')
WORKAROUND_CFLAGS += $(MNER_FLAGS)
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
CFLAGS		+= -fshort-wchar

# Include LoongArch64-specific headers
INCDIRS		:= arch/$(ARCH)/include $(INCDIRS)

# LoongArch64-specific directories containing source files
SRCDIRS		+= arch/loong64/core
SRCDIRS		+= arch/loong64/interface/efi

# Include platform-specific Makefile
MAKEDEPS	+= arch/loong64/Makefile.$(PLATFORM)
include arch/loong64/Makefile.$(PLATFORM)

=== src/arch/riscv/Makefile ===
# Assembler section type character
#
ASM_TCHAR	:= @
ASM_TCHAR_OPS	:= @

# Include RISCV-specific headers
#
INCDIRS		:= arch/$(ARCH)/include arch/riscv/include $(INCDIRS)

# RISCV-specific directories containing source files
#
SRCDIRS		+= arch/riscv/core
SRCDIRS		+= arch/riscv/interface/sbi
SRCDIRS		+= arch/riscv/prefix

# RISCV-specific flags
#
CFLAGS		+= -mno-strict-align -mno-plt

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS          += -fshort-wchar

=== src/arch/riscv32/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN32)

# RISCV32-specific directories containing source files
#
SRCDIRS		+= arch/riscv32/core
SRCDIRS		+= arch/riscv32/libgcc

# RISCV32-specific flags
#
CFLAGS		+= -march=rv32gc -mabi=ilp32d
ASFLAGS		+= -march=rv32gc -mabi=ilp32d
LDFLAGS		+= -m elf32lriscv

# Include common RISCV Makefile
#
MAKEDEPS	+= arch/riscv/Makefile
include arch/riscv/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/riscv32/Makefile.$(PLATFORM)
include arch/riscv32/Makefile.$(PLATFORM)

=== src/arch/riscv64/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN64)

# RISCV64-specific directories containing source files
#
SRCDIRS		+= arch/riscv64/core

# RISCV64-specific flags
#
CFLAGS		+= -march=rv64gc -mabi=lp64d
ASFLAGS		+= -march=rv64gc -mabi=lp64d
LDFLAGS		+= -m elf64lriscv

# Include common RISCV Makefile
#
MAKEDEPS	+= arch/riscv/Makefile
include arch/riscv/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/riscv64/Makefile.$(PLATFORM)
include arch/riscv64/Makefile.$(PLATFORM)

=== src/arch/x86_64/Makefile ===
# Specify compressor
#
ZBIN		= $(ZBIN64)

# Code size reduction.
#
CFLAGS		+= -fstrength-reduce -fomit-frame-pointer

# Code size reduction.  gcc3 needs a different syntax to gcc2 if you
# want to avoid spurious warnings.
#
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1

# Force 64-bit code
#
CFLAGS		+= -m64
ASFLAGS		+= --64
LDFLAGS		+= -m elf_x86_64

# Prevent use of MMX and SSE registers
#
CFLAGS		+= -mno-mmx -mno-sse

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# We need to undefine the default macro "i386" when compiling .S
# files, otherwise ".arch i386" translates to ".arch 1"...
#
CFLAGS			+= -Ui386

# Add -maccumulate-outgoing-args if required by this version of gcc
#
ifeq ($(CCTYPE),gcc)
MS_ABI_TEST_CODE := extern void __attribute__ (( ms_abi )) ms_abi(); \
		    void sysv_abi ( void ) { ms_abi(); }
MS_ABI_TEST = $(ECHO) '$(MS_ABI_TEST_CODE)' | \
	      $(CC) -m64 -mno-accumulate-outgoing-args -x c -c - -o /dev/null \
		    >/dev/null 2>&1
MS_ABI_FLAGS := $(shell $(MS_ABI_TEST) || $(ECHO) '-maccumulate-outgoing-args')
WORKAROUND_CFLAGS += $(MS_ABI_FLAGS)
endif

# x86_64-specific directories containing source files
#
SRCDIRS		+= arch/x86_64/core
SRCDIRS		+= arch/x86_64/prefix

# Include common x86 Makefile
#
MAKEDEPS	+= arch/x86/Makefile
include arch/x86/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/x86_64/Makefile.$(PLATFORM)
include arch/x86_64/Makefile.$(PLATFORM)

## ipxe 1.21.1+git20220113.fbbdc3926+dfsg

=== debian/changelog ===
ipxe (1.21.1+git20220113.fbbdc3926+dfsg-4) unstable; urgency=medium

  [ Miao Wang ]
  * d/rules:
    - Fix incorrect CFLAGS for architecture other than BUILD_ARCH.
    - Split build targets for any and all architectures.

  [ Shengqi Chen ]
  * Do source-only upload to allow migration.

 -- Shengqi Chen <harry@debian.org>  Tue, 04 Feb 2025 07:09:05 +0800

ipxe (1.21.1+git20220113.fbbdc3926+dfsg-3) unstable; urgency=medium

  [ Miao Wang ]
  * Split boot images & grub script into new binary package grub-ipxe
    and only installs native boot images into /boot.
  * Cross-build / multi-arch support:
    - Allow building on non x86-64 architectures.
    - Include EFI image for arm64 in the ISO image.
    - Include drivers for arm64 in the efi roms.
    - d/grub-ipxe.grub: add support for arm64
  * Packaging related:
    - Suppress false positives from blhc.
    - d/util/geniso:
      + Use -isohybrid-mbr in xorriso instead of isohybrid.
      + Fix EFI boot image size calculation.
      + Allow including EFI images for multiple architectures.
    - Add autopkgtest for generated ISO image and efi roms.

  [ Shengqi Chen ]
  * d/control: change maintainer as discussed.
    Thank Sven for salvaging and improving iPXE in Debian!
  * d/patches: update metadata.
  * d/NEWS: add entry on grub-ipxe split.

 -- Shengqi Chen <harry@debian.org>  Mon, 03 Feb 2025 06:42:00 +0800

ipxe (1.21.1+git20220113.fbbdc3926+dfsg-2) unstable; urgency=medium

  * d/rules + debian/patches/debian-changes:
    - Drop needless removal of src/bin/.gitignore and correct clean target.
  * d/p/*:
    - Drop patch debian-changes entirely.
  * d/README.source.md:
    - Drop file for describing obsolete procedures.
  * d/control:
    - Fix grammar of ipxe-qemu description.
    - Remove not used dpkg-source-gitarchive from Build-Depends.
  * d/rules:
    - Simplify pattern to pick targets to build.
  * d/rules + d/config/*:
    - Apply upstream's functionality to build roms with HTTPS support
      excluding EFI roms.
  * d/rules:
    - Simplify building of ipxe-arm64.efi
    - Avoid "warning: pattern recipe did not update peer target" by splitting
      the multi pattern target into one target per architecture.
    - Simplify mkdir invocations.
  * d/config/* + d/p/* + d/rules:
    - Convert Debian's configuration files into a patch, adapt d/rules
      accordingly.
  * d/tree + d/ipxe.grub + d/ipxe.install:
    - Rework the way the grub-mkconfig helper script gets installed.
  * d/rules:
    - Rework target override_dh_install to execute_after_dh_install.
    - In the override_dh_auto_clean recipe, replace '$(MAKE)' with an
      invocation of 'dh_auto_clean'.
    - Drop not used variable ISOLINUX_BIN.
    - Remove not needed special targets .NOTPARALLEL and .SECONDARY.
  * d/copyright:
    - Bump Debian copyright year to 2025.

 -- Sven Geuer <sge@debian.org>  Mon, 13 Jan 2025 17:11:18 +0100

ipxe (1.21.1+git20220113.fbbdc3926+dfsg-1) unstable; urgency=medium

  * d/copyright:
    - Fix Format field value.
    - Exclude drivers violating the DFSG and unneeded files of unclear
      licensing.
  * New upstream snapshot 1.21.1+git20220113.fbbdc3926+dfsg
   (Closes: #985047, #1011947).
  * d/control: Salvage package setting Maintainer to myself (Closes: #1089184).
    Thanks to Bastian Blank <waldi@debian.org> who introduced ipxe to Debian
    and maintained the package in the past.
  * d/watch: Introduce watch file.
  * d/gbp.conf: Introduce gbp configuration file.
  * d/salsa-ci.yml:
    - Introduce Salsa-Ci configuration file.
    - Add variable SALSA_CI_DISABLE_CROSSBUILD_ARM64.
  * d/p/*:
    - 9fa8c40d…fcommon.patch: Remove it for being applied upstream.
    - fix-building-with-newer-binutils.patch: update it to new upstream
      snapshot.
    - Backport from Ubuntu 0005-strip-802.1Q-VLAN-0-priority-tags.patch,
      renaming it to strip-802.1Q-VLAN-0-priority-tags.patch.
    - Backport from Ubuntu
      0003-Inhibit-linker-warnings-about-an-implied-executable-.patch,
      renaming it to inhibit-linker-warnings-about-an-implied-executable.patch.
  * d/tree/ipxe/etc/grub.d/20_ipxe:
    - Backport from Ubuntu fix about loading ipxe.efi under UEFI
      (Closes: #927783).
  * d/util/geniso:
    - Backport from Ubuntu fix to rounding to prevent broken iso creation.
    - Enhance the tool to generate a reproducible ISO image.
  * d/rules, d/util/check-rom-size: Backport this tool from Ubuntu and use it.
  * d/control, d/ipxe.install, d/ipxe.links, d/ipxe.post*, d/rules: Backport
    remaining changes from Ubuntu, which comprises:
    - Build ROMs applying the configuration upstream provides.
    - Enable HTTPS support (Closes: #847094).
    - Build ipxe-arm64.efi.
  * d/rules: Drop variable VERSION in favour of DEB_VERSION.
  * d/p/*:
    - Add patch to respect presets to CPPFLAGS, CFLAGS, LDFLAGS the
      Debian build system brings along.
    - d/p/strip-802.1Q-VLAN-0-priority-tags.patch: Update header and add
      Forwarded URL.
    - d/p/debian-changes: Add DEP3 header.
  * d/control, d/util/geniso: Use secure URLs when pointing to ipxe.org.
  * d/control:
    - Bump debhelper-compat to 13.
    - Update Standards-Version to 4.7.0.
    - Update Vcs-* to the designated repository home.
    - Add field Rules-Requires-Root with value "no".
  * d/upstream/metadata: Add upstream metadata file.
  * d/copyright: Rework copyrights and add missing ones.
  * d/ipxe-qemu.*, d/util/check-rom-sizes:
    - Move ROMs from /usr/lib/ipxe/qemu to /usr/share/qemu and remove links
      as per request from the QEMU maintainer.
  * d/config/general.h, d/config/console.h:
    - Add build options to enable background images (Closes: #955289).
  * d/rules: Add build option CERT_CMD to complement HTTPS support.
  * Apply 'wrap-and-sort -at'.

 -- Sven Geuer <sge@debian.org>  Fri, 27 Dec 2024 12:38:06 +0100

ipxe (1.0.0+git-20190125.36a4c85-5.2) unstable; urgency=medium

  * Non-maintainer upload.


=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Miao Wang <shankerwangmiao@gmail.com>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dosfstools:native,
               gcc-x86-64-linux-gnu,
               gcc-aarch64-linux-gnu,
               isolinux,
               liblzma-dev:native,
               mtools,
               syslinux-common,
               xorriso,
               xxd,
               zlib1g-dev:native,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://ipxe.org/
Vcs-Git: https://salsa.debian.org/debian/ipxe.git
Vcs-Browser: https://salsa.debian.org/debian/ipxe

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Recommends: grub-ipxe
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards
 as boot ROMs.


Package: grub-ipxe
Architecture: i386 amd64 arm64
Suggests: grub2-common
Depends: ${misc:Depends}
Breaks: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Replaces: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Description: Network booting using iPXE
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package contains bootable iPXE images and adds a menu entry to grub2 for
 network booting using iPXE.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

# qemu EFI roms shall be built with CONFIG=qemu
# This makes it apply src/config/*, src/config/qemu/*, src/config/local/*,
# src/config/local/qemu/* in this order.
src/bin-%.rom src/bin-%.efirom: export CONFIG=qemu

# Export CROSS prefix for building.
# This controls the architecture-specific build tools to be used.
src/bin-i386-pcbios/%: export CROSS=x86_64-linux-gnu-
src/bin-i386-pcbios/%: export DEB_HOST_ARCH=amd64

src/bin-x86_64-efi/%: export CROSS=x86_64-linux-gnu-
src/bin-x86_64-efi/%: export DEB_HOST_ARCH=amd64

src/bin-arm64-efi/%: export CROSS=aarch64-linux-gnu-
src/bin-arm64-efi/%: export DEB_HOST_ARCH=arm64

# used in (patched) src/Makefile
export HOST_CFLAGS = $(shell dpkg-buildflags --get CFLAGS_FOR_BUILD) $(shell dpkg-buildflags --get LDFLAGS_FOR_BUILD) -D__BLHC_IGNORE_HOSTCC

# 1. forcibly use cross tools and ignore DEB_HOST_ARCH
# 2. also setting CXX and PKG_CONFIG even if they are not used
#    to avoid confusing names in build logs
# 3. XFLAGS from env cannot be reused since DEB_HOST_ARCH is reset
define run-dh_auto_build =
@if [ "$$DEB_HOST_ARCH" != "$(DEB_BUILD_ARCH)" ]; then \
	echo "blhc: ignore-line-regexp: .*$$CROSS.*"; \
fi
CC="$${CROSS}gcc" \
CXX="$${CROSS}g++" \
PKG_CONFIG="$${CROSS}pkg-config" \
CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
CPPFLAGS="$$(dpkg-buildflags --get CPPFLAGS)" \
LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
dh_auto_build --sourcedirectory=src -- \
	V=1 NO_WERROR=1 VERSION="$(DEB_VERSION)" $(subst src/,,$@)
endef

src/bin-i386-pcbios/%:
	$(run-dh_auto_build)

src/bin-x86_64-efi/%:
	$(run-dh_auto_build)

src/bin-arm64-efi/%:
	$(run-dh_auto_build)

# efi roms are >256k since Bionic due to https + natural growth
# stay at 256k-512k after disabling https in efi via padding
define run-catrom =
@mkdir -p $(dir $@)
src/util/catrom.pl $^ > $@
src/util/padimg.pl --blksize=524288 --byte=0xff --verbose $@
endef

x86-only-roms = eepro100 ns8390 pcnet32

$(addprefix src/bin-combined/,$(addsuffix .efirom,$(x86-only-roms))): src/bin-combined/%.efirom: src/bin-i386-pcbios/%.rom src/bin-x86_64-efi/%.efirom
	$(run-catrom)

src/bin-combined/%.efirom: src/bin-i386-pcbios/%.rom src/bin-x86_64-efi/%.efirom src/bin-arm64-efi/%.efirom
	$(run-catrom)

src/bin-combined/%.iso: src/bin-i386-pcbios/%.lkrn src/bin-x86_64-efi/%.efi src/bin-arm64-efi/%.efi
	@mkdir -p $(dir $@)
	debian/util/geniso $@ $^

define get_targets
$(shell \
  for pkg in $$(dh_listpackages $(1)); do \
    if [ -e "debian/$$pkg.install" ]; then \
	  ( \
		if [ -x "debian/$$pkg.install" ]; then \
		  dh-exec --with= "debian/$$pkg.install"; \
		else \
		  cat "debian/$$pkg.install"; \
		fi \
	  ) | grep -hoE 'src/bin\S+'; \
	fi; \
  done \
)
endef

# ================
# dh targets below
# ================

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: .*__BLHC_IGNORE_HOSTCC.*"

override_dh_auto_build-indep: $(call get_targets,-i)
override_dh_auto_build-arch: $(call get_targets,-a)

execute_after_dh_install-indep:
	debian/util/check-rom-sizes

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=src -- veryclean
	rm -fr src/bin-*

=== debian/tests/control ===
Test-Command: ./debian/tests/ipxe-iso i386 cd
Depends: ipxe, expect, xxd, qemu-system-x86, seabios,
Features: test-name=iso-i386-cd

Test-Command: ./debian/tests/ipxe-iso i386 hd
Depends: ipxe, expect, xxd, qemu-system-x86, seabios,
Features: test-name=iso-i386-hd

Test-Command: ./debian/tests/ipxe-iso x86_64 cd
Depends: ipxe, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=iso-x86_64-cd

Test-Command: ./debian/tests/ipxe-iso x86_64 hd
Depends: ipxe, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=iso-x86_64-hd

Test-Command: ./debian/tests/ipxe-iso arm64 cd
Depends: ipxe, expect, xxd, qemu-system-arm, qemu-efi-aarch64,
Features: test-name=iso-arm64-cd

Test-Command: ./debian/tests/ipxe-iso arm64 hd
Depends: ipxe, expect, xxd, qemu-system-arm, qemu-efi-aarch64,
Features: test-name=iso-arm64-hd

Test-Command: ./debian/tests/ipxe-rom i386 e1000
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-e1000

Test-Command: ./debian/tests/ipxe-rom i386 e1000e
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-e1000e

Test-Command: ./debian/tests/ipxe-rom i386 rtl8139
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-rtl8139

Test-Command: ./debian/tests/ipxe-rom i386 virtio
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-virtio

Test-Command: ./debian/tests/ipxe-rom i386 vmxnet3
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-vmxnet3

Test-Command: ./debian/tests/ipxe-rom i386 eepro100
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-eepro100

Test-Command: ./debian/tests/ipxe-rom i386 ne2k_pci
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-ne2k_pci

Test-Command: ./debian/tests/ipxe-rom i386 pcnet
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-pcnet

Test-Command: ./debian/tests/ipxe-rom x86_64 e1000
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-e1000

Test-Command: ./debian/tests/ipxe-rom x86_64 e1000e
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-e1000e

Test-Command: ./debian/tests/ipxe-rom x86_64 rtl8139
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-rtl8139

Test-Command: ./debian/tests/ipxe-rom x86_64 virtio
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-virtio

Test-Command: ./debian/tests/ipxe-rom x86_64 vmxnet3
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-vmxnet3

Test-Command: ./debian/tests/ipxe-rom x86_64 eepro100
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-eepro100

Test-Command: ./debian/tests/ipxe-rom x86_64 ne2k_pci
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
